package org.processmining.featuremerge.models;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Set;

public class IndicatorValuesMatrix {

	HashMap<String, ArrayList<Double>> hm = new HashMap<String, ArrayList<Double>>();

	public int size() {
		return hm.size();
	}
	
	
	public int getNumValuesInRow() {
		int size=0;
		for(String kpi:hm.keySet()) {
			size=hm.get(kpi).size();
			break;}
		return size;
	}
	public boolean addIndicatorRow(String kpi, ArrayList<Double> values) {
		if (hm.containsKey(kpi))
			hm.replace(kpi, values);
		else
			hm.put(kpi, values);
		return true;
	}

	public boolean initializeIndicatorRow(String kpi) {
		if (!hm.containsKey(kpi)) {
			hm.put(kpi, new ArrayList<Double>());
		 	return true;}
		else return false;
	}
	
	public boolean isAvailable(String kpi) {
		if(hm.containsKey(kpi))
			return true;
		else return false;
	}
	
	public boolean addValueToRow(String kpi, Double value) {
		if (hm.containsKey(kpi)) {
			hm.get(kpi).add(value);
			return true;
		} else
			return false;
	}

	public boolean removeIndicatorRow(String kpi) {
		if (hm.containsKey(kpi)) {
			hm.remove(kpi);
			return true;
		} else
			return false;
	}

	public Set<String> getKPIs() {
		return hm.keySet();
	}
	
	public ArrayList<Double> getRow(String kpi){
		return hm.get(kpi);
	}
	
	public double getMin(String kpi) {
		return Collections.min(hm.get(kpi));
	}
	
	public double getMax(String kpi) {
		return Collections.max(hm.get(kpi));
	}
	
	public double getAvg(String kpi) {
		double sum=0;
		for (double mark : hm.get(kpi)) {
	        sum += mark;
	    }
	    return sum/hm.get(kpi).size();
	}


	public double getStdv(String kpi) {
		double stddev=0;
		ArrayList<Double> values=hm.get(kpi);
		for(double v:values) {
			    stddev += Math.pow((v-getAvg(kpi)),2);
		}
		return Math.sqrt(stddev/values.size());
	}
	
}
