package org.processmining.kpiprocessenhancementworkflow.dialogs;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.Arrays;

import javax.swing.JComboBox;
import javax.swing.JPanel;

import com.fluxicon.slickerbox.components.NiceIntegerSlider;
import com.fluxicon.slickerbox.components.NiceSlider.Orientation;
import com.fluxicon.slickerbox.factory.SlickerFactory;

public class AttributeSelectorDialog extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3587595452197538653L;
	
	private JComboBox<String> box;
	private final NiceIntegerSlider threshold;
	@SuppressWarnings("unused")

	public AttributeSelectorDialog(Object[] attributes) {
		
		SlickerFactory sl=SlickerFactory.instance();

		//Sort
		String[] stringArray = Arrays.copyOf(attributes, attributes.length, String[].class);
		Arrays.sort(stringArray);
		box=sl.createComboBox(stringArray);	
		box.setMinimumSize(new Dimension(250,30)); //Size(box.getPreferredSize().width, box.getPreferredSize().height);
	
		threshold = sl.createNiceIntegerSlider("Minimum number of occurrences for variants", 1, 1000, 1, Orientation.HORIZONTAL);
		
		
		setLayout(new GridLayout(11,1));
		
		//JLabel introduction = new JLabel("Configure the parameters for the training phase");
		//introduction.setAlignmentX(CENTER_ALIGNMENT);
		//add(introduction);
		add(SlickerFactory.instance().createLabel("Dependent characteristic:"));
		add(box);
		add(threshold);
		
		
	}
	
	public int getThreshold() {
		return threshold.getValue();
	}
	
	public String getAttributeName() {
		return (String) box.getSelectedItem();
	}
}