package org.processmining.kpiprocessenhancementworkflow.dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.kpiprocessenhancementworkflow.confs.Configuration;
import org.processmining.prediction.Augmentation.AlignmentMove;

import com.fluxicon.slickerbox.factory.SlickerFactory;




public class MovesSelectorDialog extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3587595452197538653L;

	private PairButton[][] buttonList;
	private Configuration conf;
	//private JRadioButton jrb1,jrb2,jrb3;
	
	//the HashMap to record the selected variants for each activity
	private HashMap<String,ArrayList<String>> variantsForActivity;
	
	public MovesSelectorDialog(UIPluginContext context, Configuration conf) {
		this.conf=conf;
		variantsForActivity=new HashMap<String,ArrayList<String>>();
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		JLabel introduction = new JLabel("Selects the variables related to log/model moves to train the predictor");
		introduction.setAlignmentX(LEFT_ALIGNMENT);
		add(introduction);
		
		buttonList=new PairButton[conf.getSelectedGenericColumns().size()][2];
		JPanel innerButtonPanel=new JPanel();
		GridBagConstraints c = new GridBagConstraints();
		innerButtonPanel.setLayout(new GridBagLayout());
		JButton aButton;
		aButton=SlickerFactory.instance().createButton("Activity");
		c.gridwidth=2;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx=0;
		c.gridy=0;
		c.weightx=1;
		c.weighty=1;
		innerButtonPanel.add(aButton,c);
		aButton.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {
				buttonList[0][0].setSelected(!buttonList[0][0].isSelected());
				for(int i=0;i<buttonList.length;i++)
					for(int j=0;j<buttonList[i].length;j++)
				{
					buttonList[i][j].setSelected(buttonList[0][0].isSelected());
				}
			}
		});
		
		
			    // update the value of the covering number
	/**			  JDialog dialog=new HistogramDialog(conf, buttonIcon.getName());
				  dialog.setSize(350,350);
				  dialog.setPreferredSize(new Dimension(350,350));
				  dialog.setLocationRelativeTo(null);
				 //dialog.setUndecorated(true);
				  dialog.pack();
				  dialog.setVisible(true);
		**/
		
		
		//Create the button for Log
		aButton=SlickerFactory.instance().createButton("Log");
		c.gridwidth=1;
		c.gridx=2;
		Dimension preferredSize=PairButton.buttonPreferredSize;
		aButton.setPreferredSize(preferredSize);
		innerButtonPanel.add(aButton,c); 
		
		//Create the button for Model
		aButton=SlickerFactory.instance().createButton("Model");
		aButton.setPreferredSize(preferredSize);
		c.gridx=3;
		innerButtonPanel.add(aButton,c); 
		
		int j=0;
		ArrayList<String> activityList=new ArrayList<String>();
		
		// for each dataset column add the values
		for(String activity:conf.getSelectedGenericColumns().keySet())
		{
			//keep track of all generic names of selected columns
			String act=activity.replace("Log move ", "").replace("Model move ","");
			if(!activityList.contains(act))
				activityList.add(activity.replace("Log move ", "").replace("Model move ",""));

		}

		//Sort activityList
		Collections.sort(activityList, String.CASE_INSENSITIVE_ORDER);
		
		//for each generic activity, write a row for the corresponding generic column 
		for(String column:activityList)
		{
			final String columnName=column;
			final Configuration myConf=conf;
			int valueLogColumn=0;
			int valueModelColumn=0;
			if(conf.getSelectedGenericColumns().get("Log move "+column)!=null)
				valueLogColumn=conf.getSelectedGenericColumns().get("Log move "+column);
			
			if(conf.getSelectedGenericColumns().get("Model move "+column)!=null)
			 valueModelColumn=conf.getSelectedGenericColumns().get("Model move "+column);
				
			//search if there is a log column and/or a model column for the activity at hand
			//if it is a log column
			
			c.gridy++;
			
			final PairButton pb1=new PairButton("Log move "+column,AlignmentMove.MOVE_LOG,valueLogColumn,(valueLogColumn>0));
			final PairButton pb2=new PairButton("Model move "+column,AlignmentMove.MOVE_MODEL,valueModelColumn,(valueModelColumn>0));
			buttonList[j][0]=pb1;//new PairButton("Log move "+column,AlignmentMove.MOVE_LOG,valueLogColumn,(valueLogColumn>0));
			buttonList[j][1]=pb2;
			
			buttonList[j][0].addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					  if(pb1.isSelected()) {
					  JDialog dialog=new VariantSelector("Log move "+columnName, variantsForActivity, myConf);
					  dialog.setSize(600,400);
					  //dialog.setPreferredSize(new Dimension(600,400));
					  dialog.setLocationRelativeTo(null);
					 //dialog.setUndecorated(true);
					  dialog.pack();
					  dialog.setVisible(true);
					  }
				}});
			
			buttonList[j][1].addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if(pb2.isSelected()) {
						  JDialog dialog=new VariantSelector("Model move "+columnName, variantsForActivity, myConf);
						  dialog.setSize(600,400);
						  //dialog.setPreferredSize(new Dimension(600,400));
						  dialog.setLocationRelativeTo(null);
						 //dialog.setUndecorated(true);
						  dialog.pack();
						  dialog.setVisible(true);
						  }
					}});
				
			
			
			
			aButton=SlickerFactory.instance().createButton(column);
			c.gridwidth=2;
			c.gridx=0;
			innerButtonPanel.add(aButton,c);
			c.gridwidth=1;
			c.gridx=2;
			innerButtonPanel.add(buttonList[j][0],c);
			c.gridx=3;
			innerButtonPanel.add(buttonList[j][1],c);
			j++;
		}
		JScrollPane jsp=new JScrollPane(innerButtonPanel);
		add(jsp);
		
		JPanel rounded=SlickerFactory.instance().createRoundedPanel();
		rounded.setLayout(new BoxLayout(rounded,BoxLayout.Y_AXIS));
		//setLayout(new BoxLayout(rounded, BoxLayout.Y_AXIS));
		JLabel labelChoice = new JLabel("Selects which activities should be considered");
		labelChoice.setAlignmentX(LEFT_ALIGNMENT);
			}
	
	
	/**
	 * Return the list of the selected activities (both generic and/or variants)
	 * @return an ArrayList of strings (labels of activities)
	 */
	public ArrayList<String> getSelectedActivities(){
		ArrayList<String> output=new ArrayList<String>();
		for(String act:variantsForActivity.keySet())
			output.addAll(variantsForActivity.get(act));
		
		System.out.println(output);
		return output;
	}
	
	/**
	 * Return the list of the selected activities (both generic and/or variants)
	 * @return an ArrayList of strings (labels of activities)
	 */
	public ArrayList<String> getSelectedActivities2() {
		ArrayList<String> listSelected=new ArrayList<String>();
		ArrayList<String> output=new ArrayList<String>();
		
		int maxLenght=conf.getSelectedGenericColumns().size();
		
		for(int i=0;i<maxLenght;i++)
			for(int j=0;j<=1;j++)
				if(buttonList[i][j]!=null && buttonList[i][j].isSelected()) {
					String name=buttonList[i][j].getPair().getFirst();
					listSelected.add(name);
				}
		
		System.out.println("selected columns=" + conf.getSelectedColumns().size());
			
		System.out.println(output.size()+" activities selected");
		System.out.println(output);
		return output;
	}
	
}