package org.processmining.kpiprocessenhancementworkflow.models;

import java.util.ArrayList;
import java.util.HashMap;

public class DatasetEntry {
		
		ArrayList<DatasetColumn> columns;
		HashMap<DatasetColumn,Integer> values;
		
		public DatasetEntry() {
			columns=new ArrayList<DatasetColumn>();
			values=new HashMap<DatasetColumn,Integer>();
		}
		
			public ArrayList<DatasetColumn> getColumns() {
			return columns;
		}
		public HashMap<DatasetColumn,Integer> getValues(){
			return values;
		}
		
		public void addColumn(DatasetColumn column) {
			columns.add(column);
			setValue(column, 1);
		}
		public void setValue(DatasetColumn column,int value) {
			values.put(column, value);
		}			
		
		public int getValue(DatasetColumn column) {
			int output=-1;
			for(DatasetColumn c:columns) {
				if(c.getActivity().equals(column.getActivity()) && c.getVariant()==column.getVariant()) //EDIT: aggiunto  && c.getVariant()==column.getVariant() 
					output=values.get(c);
			}
			return output;
		}
			
		public DatasetColumn containsColumn(DatasetColumn column) {	
			for(DatasetColumn c:columns) {
				//if they are of same type and they have the same name and variant
				if(c.getClass().equals(column.getClass()))
					if(c.getActivity().equals(column.getActivity()) && c.getVariant()==column.getVariant())
						return c;
			}
			return null;
				
		}
	
}
