package org.processmining.kpiprocessenhancementworkflow.models;

public class Rule {

	private String body;
	private String type;
	private double value;
	
	public Rule(String body, String type, int value) {
		this.body=body;
		this.type=type;
		this.value=value;
	}
	
	public Rule() {
		
	};

	public String getBody() {
		return body;
	}

	public void setBody(String body) {
		this.body = body;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
	
	public void setValue(double value) {
		this.value=value;
	}
	
	public double getValue() {
		return value;
	}

	/**
	 * Generates a Rule from a String containing an expression taken from the decision tree
	 * @param expression
	 * @return
	 */
	public static Rule getRuleFromExpression(String expression) {
		String type = "";

		//find the operator 
		if (expression.split(">=").length > 1)
			type = ">=";
		else if (expression.split("<=").length > 1)
			type = "<=";
		else if (expression.split(">").length > 1)
			type = ">";
		else if (expression.split("<").length > 1)
			type = "<";

		String variable = expression.split(type)[0].trim();
		String value = expression.split(type)[1].trim();

		return new Rule(variable,type,Integer.parseInt(value));
	}
}
